Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90	(revision 7521)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90	(revision 7795)
@@ -154,5 +154,5 @@
       ! Physical and dynamical ocean fields for output or passing to TOP, time-mean fields
       REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE      :: tsb_crs,tsn_crs,tsa_crs,rab_crs_n
-      REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: un_crs, vn_crs, wn_crs, rke_crs
+      REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: un_crs, vn_crs, wn_crs
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: ub_crs, vb_crs
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: hdivb_crs , hdivn_crs    
@@ -296,7 +296,7 @@
 
       ALLOCATE( ub_crs(jpi_crs,jpj_crs,jpk) , vb_crs(jpi_crs,jpj_crs,jpk) , &
-         &      un_crs(jpi_crs,jpj_crs,jpk) , vn_crs(jpi_crs,jpj_crs,jpk)    ,  wn_crs(jpi_crs,jpj_crs,jpk) , &
+         &      un_crs(jpi_crs,jpj_crs,jpk) , vn_crs(jpi_crs,jpj_crs,jpk)    ,  wn_crs(jpi_crs,jpj_crs,jpk) ,&
          &      hdivb_crs(jpi_crs,jpj_crs,jpk) , hdivn_crs(jpi_crs,jpj_crs,jpk) , &
-         &      rke_crs(jpi_crs,jpj_crs,jpk), rhop_crs(jpi_crs,jpj_crs,jpk)  , &
+         &      rhop_crs(jpi_crs,jpj_crs,jpk)  , &
          &      rb2_crs(jpi_crs,jpj_crs,jpk) ,rn2_crs(jpi_crs,jpj_crs,jpk) , &
          &      rhd_crs(jpi_crs,jpj_crs,jpk)   , rab_crs_n(jpi_crs,jpj_crs,jpk,jpts) , &
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90	(revision 7521)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90	(revision 7795)
@@ -141,9 +141,7 @@
          emp_b_crs(:,:)        = emp_crs(:,:)
          rnf_b_crs(:,:)        = rnf_crs(:,:)
-         hdivb_crs(:,:,:)      = hdivn_crs(:,:,:)
       ELSE
          emp_b_crs(:,:    ) = 0._wp
          rnf_b_crs(:,:    ) = 0._wp
-         hdivb_crs(:,:,:  ) = 0._wp
       ENDIF
 
@@ -157,10 +155,4 @@
       CALL crs_dom_ope( zs, 'VOL', 'T', tmask, zs_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
       tsb_crs(:,:,:,jp_sal) = zs_crs(:,:,:)
-
-      !  U-velocity
-      CALL crs_dom_ope( ub, 'SUM', 'U', umask, ub_crs, p_e12=e2u, p_e3=zfse3u, p_surf_crs=e2e3u_msk, psgn=-1.0 )
-
-      !  V-velocity
-      CALL crs_dom_ope( vb, 'SUM', 'V', vmask, vb_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
 
       ! n2
@@ -266,6 +258,6 @@
       CALL iom_put( "voce"  , vn_crs )   ! i-current 
 
-      !n2
-      CALL crs_dom_ope( rn2 , 'VOL', 'W', tmask, rn2_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
+!      !n2
+!      CALL crs_dom_ope( rn2 , 'VOL', 'W', tmask, rn2_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
      
       !  Horizontal divergence ( following OPA_SRC/DYN/divcur.F90 ) 
@@ -303,9 +295,6 @@
       !
       CALL iom_put( "avt", avt_crs )   !  Kz
-     
+
       !2D fields
-      CALL crs_dom_ope( utau , 'SUM', 'U', umask, utau_crs , p_e12=e2u  , p_surf_crs=e2u_crs  , psgn=1.0 )
-      CALL crs_dom_ope( vtau , 'SUM', 'V', vmask, vtau_crs , p_e12=e1v  , p_surf_crs=e1v_crs  , psgn=1.0 )
-      CALL crs_dom_ope( wndm , 'SUM', 'T', tmask, wndm_crs , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
       CALL crs_dom_ope( rnf  , 'MAX', 'T', tmask, rnf_crs                                     , psgn=1.0 )
       CALL crs_dom_ope( h_rnf, 'MAX', 'T', tmask, h_rnf_crs                                   , psgn=1.0 )
@@ -319,5 +308,4 @@
       CALL crs_dom_ope( emp   ,'SUM', 'T', tmask, emp_crs   , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
       CALL crs_dom_ope( fmmflx,'SUM', 'T', tmask, fmmflx_crs, p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
-      CALL crs_dom_ope( sfx   ,'SUM', 'T', tmask, sfx_crs   , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
 
       CALL crs_dom_ope( fr_i  ,'SUM', 'T', tmask, fr_i_crs  , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
@@ -385,5 +373,5 @@
       DO jk = jpkm1, 1, -1
          wn_crs(:,:,jk) = wn_crs(:,:,jk+1)*e1e2w_msk(:,:,jk+1) - (  hdivn_crs(:,:,jk)                                   &
-               &                          + z1_2dt * e1e2w_crs(:,:,jk) * ( e3t_a_crs(:,:,jk) - e3t_b_crs(:,:,jk) ) ) * tmask_crs(:,:,jk)
+               &                          + z1_2dt * e1e2w_msk(:,:,jk) * ( e3t_a_crs(:,:,jk) - e3t_b_crs(:,:,jk) ) ) * tmask_crs(:,:,jk)
          WHERE( e1e2w_msk(:,:,jk) .NE. 0._wp )  wn_crs(:,:,jk) =  wn_crs(:,:,jk) /e1e2w_msk(:,:,jk)
 
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_tvd_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_tvd_crs.F90	(revision 7521)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_tvd_crs.F90	(revision 7795)
@@ -144,5 +144,5 @@
          ! Surface value
          IF( lk_vvl ) THEN   ;   zwz(:,:, 1 ) = 0.e0                         ! volume variable
-         ELSE                ;   zwz(:,:, 1 ) = pwn(:,:,1) !cbr * ptb(:,:,1,jn)   ! linear free surface 
+         ELSE                ;   zwz(:,:, 1 ) = pwn(:,:,1) * ptb(:,:,1,jn)   ! linear free surface 
          ENDIF
          ! Interior value
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90	(revision 7521)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90	(revision 7795)
@@ -149,4 +149,5 @@
 
 #endif
+
             DO jk = 1, jpkm1
                DO jj = 2, jpj_crs-1
@@ -154,12 +155,11 @@
 
 #if defined key_vvl
-                     ze3ta =  ( 1. - r_vvl ) +        r_vvl   * fse3t_a_crs(ji,jj,jk)   ! after scale factor at T-point
-                     ze3tn =         r_vvl   + ( 1. - r_vvl ) * fse3t_n_crs(ji,jj,jk)   ! now   scale factor at T-point
+                     ze3ta =  ( 1. - r_vvl ) +        r_vvl   * e3t_a_crs(ji,jj,jk)   ! after scale factor at T-point
+                     ze3tn =         r_vvl   + ( 1. - r_vvl ) * e3t_n_crs(ji,jj,jk)   ! now   scale factor at T-point
 #else
                      ze3ta =  ( 1. - r_vvl ) +        r_vvl   * e3t_0_crs(ji,jj,jk)   ! after scale factor at T-point
                      ze3tn =         r_vvl   + ( 1. - r_vvl ) * e3t_0_crs(ji,jj,jk)   ! now   scale factor at T-point
 #endif
-                     !cbr zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * e3w_1d(jk  ) )  !cc
-                     !cbr zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * e3w_1d(jk+1) )  !cc
+
                      zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * fse3w_max_crs(ji,jj,jk) )
                      zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * fse3w_max_crs(ji,jj,jk+1) )
@@ -209,6 +209,6 @@
             DO ji = 2, jpi_crs-1
 #if defined key_vvl
-               ze3tb = ( 1. - r_vvl ) + r_vvl * fse3t_b_crs(ji,jj,1)
-               ze3tn = ( 1. - r_vvl ) + r_vvl * fse3t_n_crs(ji,jj,1)
+               ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_b_crs(ji,jj,1)
+               ze3tn = ( 1. - r_vvl ) + r_vvl * e3t_n_crs(ji,jj,1)
 #else
                ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_0_crs(ji,jj,1)
@@ -223,6 +223,6 @@
                DO ji = 2, jpi_crs-1
 #if defined key_vvl
-                  ze3tb = ( 1. - r_vvl ) + r_vvl * fse3t_b_crs(ji,jj,jk)
-                  ze3tn = ( 1. - r_vvl ) + r_vvl * fse3t_n_crs(ji,jj,jk)
+                  ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_b_crs(ji,jj,jk)
+                  ze3tn = ( 1. - r_vvl ) + r_vvl * e3t_n_crs(ji,jj,jk)
 #else
                   ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_0_crs(ji,jj,jk)
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 7521)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 7795)
@@ -147,12 +147,5 @@
 
 #if defined key_vvl 
-   USE crs , ONLY :   e3t        =>  e3t_n_crs         !: vertical scale factors at t-
-   USE crs , ONLY :   e3u        =>  e3u_n_crs         !: vertical scale factors at u-
-   USE crs , ONLY :   e3v        =>  e3v_n_crs         !: vertical scale factors v-
-   USE crs , ONLY :   e3w        =>  e3w_n_crs         !: w-points (m)
    USE crs , ONLY :   e3t_b      =>  e3t_b_crs         !: vertical scale factors at t-
-   USE crs , ONLY :   e3u_b      =>  e3u_b_crs         !: vertical scale factors at u-
-   USE crs , ONLY :   e3v_b      =>  e3v_b_crs         !: vertical scale factors v-
-   USE crs , ONLY :   e3w_b      =>  e3w_b_crs         !: w-points (m)
    USE crs , ONLY :   e3t_n      =>  e3t_n_crs         !: vertical scale factors at t-
    USE crs , ONLY :   e3u_n      =>  e3u_n_crs         !: vertical scale factors at u-
@@ -160,15 +153,5 @@
    USE crs , ONLY :   e3w_n      =>  e3w_n_crs         !: w-points (m)
    USE crs , ONLY :   e3t_a      =>  e3t_a_crs         !: vertical scale factors at t-
-   USE crs , ONLY :   e3u_a      =>  e3u_a_crs         !: vertical scale factors at u-
-   USE crs , ONLY :   e3v_a      =>  e3v_a_crs         !: vertical scale factors v-
-   USE crs , ONLY :   e3w_a      =>  e3w_a_crs         !: w-points (m)
-   USE crs , ONLY :   gdept      =>  gdept_n_crs       !: depth of t-points (m)
-   USE crs , ONLY :   gdept_crs  =>  gdept_n_crs       !: depth of t-points (m)
    USE crs , ONLY :   gdept_n    =>  gdept_n_crs       !: depth of t-points (m)
-   USE crs , ONLY :   gdepw_n    =>  gdepw_n_crs       !: depth of t-points (m)
-   USE crs , ONLY :   e3t_max_crs => e3t_max_n_crs
-   USE crs , ONLY :   e3u_max_crs => e3u_max_n_crs
-   USE crs , ONLY :   e3v_max_crs => e3v_max_n_crs
-   USE crs , ONLY :   e3w_max_crs => e3w_max_n_crs
 #else
    USE crs , ONLY :   e3t        =>  e3t_0_crs         !: vertical scale factors at t-
@@ -199,25 +182,9 @@
    USE crs , ONLY :   e3w_max_crs => e3w_max_0_crs
 #endif
-   USE crs , ONLY :   e3t_0        =>  e3t_0_crs         !: vertical scale factors at t-
-   USE crs , ONLY :   e3u_0        =>  e3u_0_crs         !: vertical scale factors at t-
-   USE crs , ONLY :   e3v_0        =>  e3v_0_crs         !: vertical scale factors at t-
-   USE crs , ONLY :   e3w_0        =>  e3w_0_crs         !: vertical scale factors at t-
-
-   USE crs , ONLY     :   ff         =>  ff_crs         !: f-points (m)
-   USE crs , ONLY     :   gdept_0    =>  gdept_0_crs       !: depth of t-points (m)
    USE dom_oce , ONLY :   gdept_1d   =>  gdept_1d      !: depth of t-points (m)
-#if defined key_zco
-   USE crs , ONLY :   gdept      =>  gdept_0_crs       !: depth of t-points (m)
-   USE crs , ONLY :   gdepw      =>  gdepw_crs       !: depth of t-points (m)
-#endif
   !* masks, bathymetry *
    USE crs , ONLY :   mbkt       =>   mbkt_crs       !: vertical index of the bottom last T- ocean level
-   USE crs , ONLY :   mbku       =>   mbku_crs       !: vertical index of the bottom last U- ocean level
-   USE crs , ONLY :   mbkv       =>   mbkv_crs       !: vertical index of the bottom last V- ocean level
    USE crs , ONLY :   tmask_i    =>   tmask_i_crs    !: Interior mask at t-points
    USE crs , ONLY :   tmask      =>   tmask_crs      !: land/ocean mask at t-points
-   USE crs , ONLY :   umask      =>   umask_crs      !: land/ocean mask at u-points   
-   USE crs , ONLY :   vmask      =>   vmask_crs      !: land/ocean mask at v-points 
-   USE crs , ONLY :   fmask      =>   fmask_crs      !: land/ocean mask at f-points 
 
  !* ocean fields: here now and after fields *
@@ -226,12 +193,6 @@
    USE crs , ONLY :   wn      =>    wn_crs      !: vertical velocity (m s-1)  
    USE crs , ONLY :   tsn     =>    tsn_crs     !: 4D array contaning ( tn, sn )
-   USE crs , ONLY :   tsb     =>    tsb_crs     !: 4D array contaning ( tb, sb )
-   USE crs , ONLY :   tsa     =>    tsa_crs     !: 4D array contaning ( ta, sa )
    USE crs , ONLY :   rhop    =>    rhop_crs    !: potential volumic mass (kg m-3) 
-   USE crs , ONLY :   rhd     =>    rhd_crs    !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
-   USE crs , ONLY :   rn2b    =>    rb2_crs     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
-   USE crs , ONLY :   rab_n   =>    rab_crs_n     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
    USE crs , ONLY :   hdivn   =>    hdivn_crs   !: horizontal divergence (1/s)
-   USE crs , ONLY :   hdivb   =>    hdivb_crs   !: horizontal divergence (1/s)
    USE crs , ONLY :   sshb    =>    sshb_crs    !: sea surface height at t-point [m]   
    USE crs , ONLY :   sshn    =>    sshn_crs    !: sea surface height at t-point [m]   
@@ -239,11 +200,7 @@
 
    !* surface fluxes *
-   USE crs , ONLY :   utau       =>    utau_crs       !: i-surface stress component
-   USE crs , ONLY :   vtau       =>    vtau_crs       !: j-surface stress component
-   USE crs , ONLY :   wndm       =>    wndm_crs       !: 10m wind speed 
    USE crs , ONLY :   qsr        =>    qsr_crs        !: penetrative solar radiation (w m-2)  
    USE crs , ONLY :   emp        =>    emp_crs        !: freshwater budget: volume flux               [Kg/m2/s]
    USE crs , ONLY :   emp_b      =>    emp_b_crs      !: freshwater budget: volume flux               [Kg/m2/s]
-   USE crs , ONLY :   sfx        =>    sfx_crs        !: freshwater budget: concentration/dillution   [Kg/m2/s]
    USE crs , ONLY :   fmmflx     =>    fmmflx_crs     !: freshwater budget: volume flux               [Kg/m2/s]
    USE crs , ONLY :   rnf        =>    rnf_crs        !: river runoff   [Kg/m2/s]
@@ -251,4 +208,5 @@
    USE crs , ONLY :   nk_rnf     =>    nk_rnf_crs     !: depth of runoff in model level
    USE crs , ONLY :   fr_i       =>    fr_i_crs       !: ice fraction (between 0 to 1)
+
    USE trcnam_trp , ONLY :  aht0     =>   rn_ahtrc_0        !: horizontal eddy diffusivity for tracers (m2/s)
    USE crs , ONLY :  ahtu     =>   ahtu_crs        !: lateral diffusivity coef. at u-points 
@@ -258,17 +216,11 @@
    USE crs , ONLY :  r_fact_lap     =>  r_fact_lap_crs        !: enhanced zonal diffusivity coefficient
    USE ldftra_oce , ONLY :  rldf     =>   rldf
+
    USE crs , ONLY :  trc_i => trc_i_crs
    USE crs , ONLY :  trc_o => trc_o_crs
+
    USE crs , ONLY :   avt        =>   avt_crs         !: vert. diffusivity coef. at w-point for temp  
-#if defined key_zdfddm
-   USE crs , ONLY :   avs        =>   avs_crs         !: salinity vertical diffusivity coeff. at w-point
-#endif
-
-   USE trc_oce, ONLY : nn_dttrc
-
-   USE crs , ONLY :   nmln        =>   nmln_crs        !: number of level in the mixed layer
    USE crs , ONLY :   hmld        =>   hmld_crs        !: mixing layer depth (turbocline)
    USE crs , ONLY :   hmlp        =>   hmlp_crs        !: mixed layer depth  (rho=rho0+zdcrit) (m)
-   USE crs , ONLY :   hmlpt       =>   hmlpt_crs       !: mixed layer depth at t-points (m)
 
   !* direction of lateral diffusion *
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcsub.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 7521)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 7795)
@@ -110,5 +110,4 @@
           fmmflx_tm(:,:)         = fmmflx_tm(:,:)         + fmmflx(:,:)
           qsr_tm   (:,:)         = qsr_tm   (:,:)         + qsr   (:,:)
-          wndm_tm  (:,:)         = wndm_tm  (:,:)         + wndm  (:,:)
 
       ELSE                           !  It is time to substep 
@@ -152,14 +151,11 @@
          fmmflx_temp(:,:)        = fmmflx(:,:)
          qsr_temp   (:,:)        = qsr   (:,:)
-         wndm_temp  (:,:)        = wndm  (:,:)
          !                                    !  Variables reset in trc_sub_ssh
 #if ! defined key_crs
          rotn_temp  (:,:,:)      = rotn  (:,:,:)
 # endif
-         hdivn_temp (:,:,:)      = hdivn (:,:,:)
 #if ! defined key_crs
          rotb_temp  (:,:,:)      = rotb  (:,:,:)
 # endif
-         hdivb_temp (:,:,:)      = hdivb (:,:,:)
          !
          ! 2. Create averages and reassign variables
@@ -199,5 +195,4 @@
          fmmflx_tm(:,:)          = fmmflx_tm  (:,:)       + fmmflx(:,:)
          qsr_tm   (:,:)          = qsr_tm     (:,:)       + qsr   (:,:)
-         wndm_tm  (:,:)          = wndm_tm    (:,:)       + wndm  (:,:)
          !
          sshn     (:,:)          = sshn_tm    (:,:) * r1_ndttrcp1 
@@ -211,5 +206,4 @@
          emp_b    (:,:) = emp_b_hold (:,:)
          IF( kt == nittrc000 ) THEN
-            wndm  (:,:)          = wndm_tm    (:,:) * r1_ndttrc 
             qsr   (:,:)          = qsr_tm     (:,:) * r1_ndttrc 
             emp   (:,:)          = emp_tm     (:,:) * r1_ndttrc 
@@ -227,5 +221,4 @@
 # endif
          ELSE
-            wndm  (:,:)          = wndm_tm    (:,:) * r1_ndttrcp1 
             qsr   (:,:)          = qsr_tm     (:,:) * r1_ndttrcp1 
             emp   (:,:)          = emp_tm     (:,:) * r1_ndttrcp1 
@@ -389,5 +382,4 @@
       emp_b (:,:)     =  emp_b_temp (:,:)
       qsr   (:,:)     =  qsr_temp   (:,:)
-      wndm  (:,:)     =  wndm_temp  (:,:)
 # if defined key_trabbl
       IF( nn_bbl_ldf == 1 ) THEN
@@ -402,5 +394,4 @@
       !
       hdivn (:,:,:)   =  hdivn_temp (:,:,:)
-      hdivb (:,:,:)   =  hdivb_temp (:,:,:)
 #if ! defined key_crs
       rotn  (:,:,:)   =  rotn_temp  (:,:,:)
@@ -438,5 +429,4 @@
       fmmflx_tm  (:,:) = fmmflx(:,:)
       qsr_tm     (:,:) = qsr   (:,:)
-      wndm_tm    (:,:) = wndm  (:,:)
 # if defined key_trabbl
       IF( nn_bbl_ldf == 1 ) THEN